import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Ein Schmetterling hllt Pollichen von der Arbeit ab. Berhrt Pollinchen
 * den Schmetterling hast du verloren!!
 */
public class Schmetterling  extends mover
{
   
    private static final double WALKING_SPEED = 3.5;   

        /**
         * Vergleich "Little Crab"
         * Zuflliges Verhalten: Der Schnetterlingt dreht sich.
         * Wenn eine Zufallszahl kleiner als zehn geliefert wird, so dreht der Schmetterling
         * sich in einem zuflligen Winkel, zwischen 90 und 45 Grad.
         */
     
            public void act() 
            {
         if ( atWorldEdge() ) 
        {
            turn(17);
        }
     
        if ( Greenfoot.getRandomNumber(100) < 10 ) 
        {
            turn( Greenfoot.getRandomNumber(90)-45 );
        }


        lookForBiene();
        move();
    
      }    
      /**
      * Wenn der Schmetterling die Biene sieht, wird sie aufgegessen.
      * Und der Sound "slurp" wird abgespielt. Das Objekt "Verloren wir eingefgt 
      * und das Spiel stoppt.
      */
      public void lookForBiene()
      {
        if (canSee(Biene.class))
        {
            eat (Biene.class);
            Greenfoot.playSound("au.wav");
          
            
            
             getWorld().addObject (new Verloren(), 257, 222);
            Greenfoot.stop ();
        }
      }
       
            
      public void turn(int angle)
      {
        setRotation(getRotation() + angle);
      }
    
    
      public void move()
      { 
        double angle = Math.toRadians( getRotation() );
        int x = (int) Math.round(getX() + Math.cos(angle) * WALKING_SPEED);
        int y = (int) Math.round(getY() + Math.sin(angle) * WALKING_SPEED);
        
        setLocation(x, y);
      }
    
      public boolean canSee(Class clss)
      {
        Actor actor = getOneObjectAtOffset(0, 0, clss);
        return actor != null;        
      }
    
    
       /**
      * wenn die x- oder y -Koordinate kleiner 20 ist liefere den Wert "true" zurck.
      * ansoansten "false"
      */
      public boolean atWorldEdge()
      {
        if(getX() < 20 || getX() > getWorld().getWidth() - 20)
            return true;
        if(getY() < 20 || getY() > getWorld().getHeight() - 20)
            return true;
        else
            return false;
      }
    }    

 



